; 8051 Startup Routine for Crossware C Compiler
; This startup routine is provided as an example only.  It must be modified to suit your
; target system.

; The following block will be maintained by the Embedded Development Studio
; DO NOT EDIT
;{{EDS_STARTUP(C8051.ASM)
__NoRom equ 0
__LowestRomLocation equ 0H
__HighestRomLocation equ 07DFDH
__LowestXDataLocation equ 0H
__HighestXDataLocation equ 07FFH
__HighestIDataLocation equ 0FFH
__ExternalStack equ 0
__ExternalHeap equ 0
__InternalHeap equ 1
__UseIoStreams equ 0
;}}EDS_STARTUP
; END OF DO NOT EDIT
; This is the end of the block that will be maintained by the Embedded Development Studio

	extrn	code(_main,__initbits,__initdata,__initidata,__initbdata,__initxdata,__initiostreams)
	ifne	__ExternalStack
	extrn	data(__XSP)
	endc
	ifne	__ExternalHeap
	extrn	data(__XHP)
	endc
	ifne	__InternalHeap
	extrn	data(__IHP)
	endc
	public	__cstart

__ISTACK	segment	idata postpone	; linker places this segment after all other idata segments
	rseg	__ISTACK
	ds	1			; 1 byte minimum to create segment

	ifne	__ExternalStack				; compiler need an external stack
__XSTACK	segment	xdata postpone		; linker places this segment after all other xdata segments except __XHEAP
	rseg	__XSTACK
	ds	1
	endc

	ifne	__ExternalHeap				; compiler need an external heap
__XHEAP segment xdata high 	; linker places this segment at highest available in external ram
	rseg	__XHEAP
	ds	1
	endc
	
	ifne	__InternalHeap				; compiler need an internal heap
__IHEAP segment idata high
	rseg __IHEAP
	ds	1
	endc


	; Set up program start

	ifeq	__NoRom 		; Execution starts at address zero on power up
; Execution immediately jumps to __cstart.
	cseg	at	__LowestRomLocation		; absolute segment starting at start of ROM
	jmp	__cstart
__CODE	segment	code
	rseg	__CODE
	endc
	ifne	__NoRom 		; Program will go into ram
							; We assume that a monitor is running on the target system
							; We create an absolute segment starting at the lowest available
							; xdata location and execution should be started at this address
							; by a monitor command
	cseg	at	__LowestXDataLocation
	endc
; The compiler generates a reference to '__cstart' to force the linker to include at least
; one module with this label. Therefore you should use '__cstart' in this file otherwise
; you will get an error message from the linker or a second startup module (extracted
; from the library) will be included in the final program.
__cstart
	public __START	; tell the linker the start address
__START
	mov	SP,#__ISTACK		; set up real stack
	ifne	__ExternalStack
	mov	__XSP,#LOW(__XSTACK)	; set up pseudo stack (grows up)
	mov	__XSP+1,#HIGH(__XSTACK)
	endc
	ifne	__ExternalHeap
	mov	__XHP,#LOW(__XHEAP)	; set up heap pointer (grows down)
	mov	__XHP+1,#HIGH(__XHEAP)
	endc
	ifne	__InternalHeap
	mov	__IHP,#__IHEAP		; set up heap in internal memory
	endc
	using	0			; make linker reserve space for register bank 0
	clr	RS0			; set up register bank 0
	clr	RS1

;***********************************************************************************
;	Add your target specific initialisation code here
;	For instance you may wish to initialise a watchdog timer
; By default, call _init_chip in xstdsys.c which contains initialisation code 
; generated by the Wizards

	extrn	code(__init_chip)
	call	__init_chip

;***********************************************************************************

	call	__initbits		; __initbits must be called if _bit variables are used
	call	__initdata		; __initdata must be called if _data variables are used
	call	__initbdata		; __initbdata must be called if _bdata variables are used
	call	__initidata		; __initidata must always be called to initialise C variables in internal ram
					; unless the large memory model is being used and not _idata variables are used
	ifne __HighestXDataLocation 	; if __HighestXDataLocation is not zero, there is some external ram
	call	__initxdata		; __initxdata must always be called to initialise C variables in external ram
	endc
	ifne __UseIoStreams
	call	__initiostreams		; initialise stdout, stdin, stderr, stdaux
	endc

	extrn code(__init_chip1)
	call __init_chip1

	call	_main			; call users program
	jmp	0			; need to jump to a meaningful address if program ever exits  
