/* Crossware Standard System C File for Cygnal variants C8051F000, C8051F001, 
 * C8051F002, C8051F005, C8051F006, C8051F007, C8051F010, C8051F011, C8051F012, 
 * C8051F015, C8051F016, C8051F017
 *
 * The Crossware Embedded Development Studio will automatically switch Standard System
 * Files if you change to a variant that requires a different one. The one being
 * replaced will be saved in your project directory and will be automatically restored
 * if you change back to a variant that it supports.
 */

// Embedded Development Studio identification info, do not remove:
//{{EDS_STDFILE(C8051F0XX.C)
//}}EDS_STDFILE

#include "xstdsys.h"


void _init_chip()
{
	// Note that this function is called before any C variables have been initialised.

	// Do not edit the configuration blocks manually, use the Wizards (see the Wizards menu)
	// You can change the location of the configuration blocks if you wish,
	// as long as they remain in this file

	//{{EDS_CONFIG(WATCHDOG)
	_wdtcn = 0XDE;
	_wdtcn = 0XAD;
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(OSCILLATORS)
	// External oscillator frequency: 22118400
	_oscxcn = _XOSCMD2 | _XOSCMD1 | _XFCN2 | _XFCN1 | _XFCN0;
	_oscicn |= _CLKSL;
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(PORTS)
	_prt0cf = 0XFF;
	_xbr0 = _UARTEN;
	_xbr2 |= _XBARE;
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(XMEMORY)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(FLASH)
	//}}EDS_CONFIG

}

void _init_chip1()
{
	// This function is called after the C variables have been initialised, just before the call to main

	//{{EDS_CONFIG(UART0)
	// Using external oscillator
	_scon = _SM1 | _REN;
	_ie |= _EA | _ES;
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(TIMER0)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(TIMER1)
	_tmod |= _T1M1;
	_ckcon |= _T1M;
	_tl1 = 0XFA;
	_th1 = 0XFA;
	_tr1 = 1;
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(TIMER2)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(TIMER3)
	_tmr3cn = _T3M;
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(ADC0)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(COMPARATOR0)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(COMPARATOR1)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(REFERENCES)
	_ref0cn = _BIASE | _REFBE;
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(DAC0)
	_dac0cn = _DAC0EN;
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(DAC1)
	_dac1cn = _DAC1EN;
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(PCA0)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(SPI0)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(SMBUS0)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(EX01)
	//}}EDS_CONFIG
	
	//{{EDS_CONFIG(EX4567)
	//}}EDS_CONFIG
	
}
